---
title: Reflect
slug: Web/JavaScript/Reference/Global_Objects/Reflect
tags:
  - ECMAScript 2015
  - JavaScript
  - Namespace
  - Overview
  - Reflect
---
<div>{{JSRef}}</div>

<p><span class="seoSummary"><strong>Reflect</strong> is a built-in object that provides methods for interceptable JavaScript operations. The methods are the same as those of <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Proxy/handler">proxy handlers</a>. <code>Reflect</code> is not a function object, so it's not constructible.</span></p>

<h2 id="Description">Description</h2>

<p>Unlike most global objects, <code>Reflect</code> is not a constructor. You cannot use it with a <a href="/en-US/docs/Web/JavaScript/Reference/Operators/new"><code>new</code> operator</a> or invoke the <code>Reflect</code> object as a function. All properties and methods of <code>Reflect</code> are static (just like the {{jsxref("Math")}} object).</p>

<p>The <code>Reflect</code> object provides the following static functions which have the same names as the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Proxy/handler">proxy handler methods</a>.</p>

<p>Some of these methods are also the same as corresponding methods on {{jsxref("Object")}}, although they do have <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Reflect/Comparing_Reflect_and_Object_methods">some subtle differences</a> between them.</p>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{jsxref("Reflect.apply()", "Reflect.apply(<var>target</var>, <var>thisArgument</var>, <var>argumentsList</var>)")}}</dt>
 <dd>Calls a <code><var>target</var></code> function with arguments as specified by the <code><var>argumentsList</var></code> parameter. See also {{jsxref("Function.prototype.apply()")}}.</dd>
 <dt>{{jsxref("Reflect.construct()", "Reflect.construct(<var>target</var>, <var>argumentsList</var>[, <var>newTarget</var>])")}}</dt>
 <dd>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/new"><code>new</code> operator</a> as a function. Equivalent to calling <code>new <var>target</var>(...<var>argumentsList</var>)</code>. Also provides the option to specify a different prototype.</dd>
 <dt>{{jsxref("Reflect.defineProperty()", "Reflect.defineProperty(<var>target</var>, <var>propertyKey</var>, <var>attributes</var>)")}}</dt>
 <dd>Similar to {{jsxref("Object.defineProperty()")}}. Returns a {{jsxref("Boolean")}} that is <code>true</code> if the property was successfully defined.</dd>
 <dt>{{jsxref("Reflect.deleteProperty()", "Reflect.deleteProperty(<var>target</var>, <var>propertyKey</var>)")}}</dt>
 <dd>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete"><code>delete</code> operator</a> as a function. Equivalent to calling <code>delete <var>target</var>[<var>propertyKey</var>]</code>.</dd>
 <dt>{{jsxref("Reflect.get()", "Reflect.get(<var>target</var>, <var>propertyKey</var>[, <var>receiver</var>])")}}</dt>
 <dd>Returns the value of the property. Works like getting a property from an object (<code>target[propertyKey]</code>) as a function.</dd>
 <dt>{{jsxref("Reflect.getOwnPropertyDescriptor()", "Reflect.getOwnPropertyDescriptor(<var>target</var>, <var>propertyKey</var>)")}}</dt>
 <dd>Similar to {{jsxref("Object.getOwnPropertyDescriptor()")}}. Returns a property descriptor of the given property if it exists on the object,  {{jsxref("undefined")}} otherwise.</dd>
 <dt>{{jsxref("Reflect.getPrototypeOf()", "Reflect.getPrototypeOf(<var>target</var>)")}}</dt>
 <dd>Same as {{jsxref("Object.getPrototypeOf()")}}.</dd>
 <dt>{{jsxref("Reflect.has()", "Reflect.has(<var>target, propertyKey</var>)")}}</dt>
 <dd>Returns a {{jsxref("Boolean")}} indicating whether the target has the property. Either as own or inherited. Works like the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a> as a function.</dd>
 <dt>{{jsxref("Reflect.isExtensible()", "Reflect.isExtensible(<var>target</var>)")}}</dt>
 <dd>Same as {{jsxref("Object.isExtensible()")}}. Returns a {{jsxref("Boolean")}} that is <code>true</code> if the target is extensible.</dd>
 <dt>{{jsxref("Reflect.ownKeys()", "Reflect.ownKeys(<var>target</var>)")}}</dt>
 <dd>Returns an array of the target object's own (not inherited) property keys.</dd>
 <dt>{{jsxref("Reflect.preventExtensions()", "Reflect.preventExtensions(<var>target</var>)")}}</dt>
 <dd>Similar to {{jsxref("Object.preventExtensions()")}}. Returns a {{jsxref("Boolean")}} that is <code>true</code> if the update was successful.</dd>
 <dt>{{jsxref("Reflect.set()", "Reflect.set(<var>target</var>, <var>propertyKey</var>, <var>value</var>[, <var>receiver</var>])")}}</dt>
 <dd>A function that assigns values to properties. Returns a {{jsxref("Boolean")}} that is <code>true</code> if the update was successful.</dd>
 <dt>{{jsxref("Reflect.setPrototypeOf()", "Reflect.setPrototypeOf(<var>target</var>, <var>prototype</var>)")}}</dt>
 <dd>A function that sets the prototype of an object. Returns a {{jsxref("Boolean")}} that is <code>true</code> if the update was successful.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Detecting_whether_an_object_contains_certain_properties">Detecting whether an object contains certain properties</h3>

<pre class="brush: js">const duck = {
  name: 'Maurice',
  color: 'white',
  greeting: function() {
    console.log(`Quaaaack! My name is ${this.name}`);
  }
}

Reflect.has(duck, 'color');
// true
Reflect.has(duck, 'haircut');
// false</pre>

<h3 id="Returning_the_objects_own_keys">Returning the object's own keys</h3>

<pre class="brush: js">Reflect.ownKeys(duck);
// [ "name", "color", "greeting" ]</pre>

<h3 id="Adding_a_new_property_to_the_object">Adding a new property to the object</h3>

<pre class="brush: js">Reflect.set(duck, 'eyes', 'black');
// returns "true" if successful
// "duck" now contains the property "eyes: 'black'"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect-object', 'Reflect')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{jsxref("Proxy")}} global object.</li>
 <li>The {{jsxref("Proxy.handler", "handler")}} object.</li>
</ul>
